/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*-  */
/*
 * main.c
 * Copyright (C) 2013 Andrew Smith <Andrew@GNAServicesInc.com>
 *
 * tpad is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * tpad is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
////////////////////////////////////////////////////////////////////////

#ifndef _GNU_SOURCE
#define _GNU_SOURCE
#endif
#ifndef __USE_FILE_OFFSET64
#define __USE_FILE_OFFSET64
#endif
#ifndef _FILE_OFFSET_BITS 
#define _FILE_OFFSET_BITS 64
#endif
#ifndef _FORTIFY_SOURCE
#define _FORTIFY_SOURCE 2
#endif
#ifndef __USE_FORTIFY_LEVEL
#define __USE_FORTIFY_LEVEL 2
#endif
////////////////////////////////////////////////////////////////////////



////////////////////////////////////////////////////////////////////////

#include "tpad_headers.h"


////////////////////////////////////////////////////////////////////////
 int scan_this_dir (gchar* cdir);
////////////////////////////////////////////////////////////////////////
const gchar COPPYRIGHT_NOTICE[78] = {"Copyright (C) 2013 Andrew Smith (GNA SERVICES INC) <Andrew@GNAServicesInc.com>"};
const gchar LICENSE_NOTICE[695] = {"Copyright (C) 2013 Andrew Smith (GNA SERVICES INC) <Andrew@GNAServicesInc.com>\n\ntpad is free software: you can redistribute it and/or modify it\nunder the terms of the GNU General Public License as published by the\nFree Software Foundation, either version 3 of the License, or\n(at your option) any later version.\n\ntpad is distributed in the hope that it will be useful, but\nWITHOUT ANY WARRANTY; without even the implied warranty of\nMERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.\nSee the GNU General Public License for more details.\n\nYou should have received a copy of the GNU General Public License along\nwith this program.  If not, see <http://www.gnu.org/licenses/>.\n"};
////////////////////////////////////////////////////////////////////////
static GdkDisplay* Display;

int
main (int argc, char *argv[])
{


	////////////////////////////////////////////////////////////////////////
	// Native Language Support Int
	////////////////////////////////////////////////////////////////////////
#ifdef ENABLE_NLS
	bindtextdomain (GETTEXT_PACKAGE, PACKAGE_LOCALE_DIR);
	bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
	textdomain (GETTEXT_PACKAGE);
#endif
	////////////////////////////////////////////////////////////////////////
	set_path_self((char *)argv[0]);
	////////////////////////////////////////////////////////////////////////
	/* GTK INIT */
	////////////////////////////////////////////////////////////////////////
	gtk_init(&argc,&argv);
  	////////////////////////////////////////////////////////////////////////
	/* CONFIG Setup */
	////////////////////////////////////////////////////////////////////////
	config_setup();
	////////////////////////////////////////////////////////////////////////
	// Get information on the display for use with config. 
	////////////////////////////////////////////////////////////////////////
	gint idisplayNumber=0,mwidth=0,mheight=0;
	Display=gdk_display_manager_get_default_display (gdk_display_manager_get());
	idisplayNumber = gdk_display_get_n_screens (Display);
	int i=0;
	for (i=0;i < idisplayNumber; i++){
		GdkScreen* Screen;
		Screen=gdk_display_get_screen(Display,i);
		mwidth+=gdk_screen_get_width(Screen);
		mheight+=gdk_screen_get_height(Screen);
	}
	cfg_set_screen_width(mwidth);
	cfg_set_screen_height(mheight);

	tpad_init_buff();
	 build_window();
	new_file();

	////////////////////////////////////////////////////////////////////////
	// handle cl arguments
	////////////////////////////////////////////////////////////////////////

		if (argc >=2){
		int i=0;			
		for (i = 1; i < argc; i++) {		
			if(i==1) {
				if( is_path_a_directory(g_strdup(argv[1])) == TRUE) scan_this_dir(g_strdup(argv[1]));
				else show_file( g_strdup(argv[1]));
			}
			else open_file_path_append_stack(g_strdup(argv[i]));				
	}
		}
	////////////////////////////////////////////////////////////////////////
	tpad_show_window();

	////////////////////////////////////////////////////////////////////////
	/* GTK MAIN */
	////////////////////////////////////////////////////////////////////////
    	gtk_main();
	////////////////////////////////////////////////////////////////////////
	return (0);

}


 int scan_this_dir (gchar* cdir){
	struct dirent *entry = NULL;
	 DIR *dir=opendir(cdir);
	
	while(entry = readdir(  dir ) ){
		static gchar* fName=NULL;
	    static gchar *uName=NULL;
		static gchar *oName=NULL;
		fName=(gchar*)entry->d_name;
		uName=g_strconcat(cdir,(gchar*)"/",clean_path(g_strdup(fName)),NULL);
		oName=clean_path(g_strdup(uName));
		if(str_size(fName) == 1 || str_size(fName) == (gint) 2) continue;
		if(file_open_check_ok(g_strdup(oName))) open_file_path_append_stack( g_strdup(oName));
	}
	closedir(dir);
	 return(0);
}
